
expit     <- function(x) exp(x) / (1 + exp(x))
logit     <- function(p) log(p) - log(1-p)

InVEx<- function(Alp.Hat, nik) {
  a <- 1
  b <- Alp.Hat
  PP<- matrix(1, nik, nik)
  CovM <- b*PP + (a-b)*diag(1, nik)
  inV <- (-b/((a-b)*(nik*b+a-b)))*PP + diag(1,nik)/(1-b)   
  inV
} 


   



DeltaComp <- function(SSS, nh, Nh){
  H <- length(unique(SSS))
  NAM <- unique(SSS)
  pi_pi2 <- (nh/Nh) %*% t(nh/Nh)
  for(h in 1:H)
  {
    SSS.h <- (SSS == NAM[h])
    pi_pi2[SSS.h, SSS.h] <- (nh[SSS.h]/Nh[SSS.h]) %*% t((nh[SSS.h]-1)/(Nh[SSS.h]-1))
  }
  diag(pi_pi2) <- nh/Nh
  Delta <- pi_pi2 - (nh/Nh) %*% t(nh/Nh)
  return(list(pi_pi2, Delta))
}

piCluster <- function(Nh, nh, sh , id, cons=100){
  ids <- unique(id)
  K   <- length(ids)
  pkv <- matrix(0, K,2)
  for (k in 1:K){
    idk <- ids[k]
    nk  <- nh[id==idk]
    Nk  <- Nh[id==idk]
    sk  <- sh[id==idk]
    
    prk  <-1  ;  sk2 <- unique(sk)
    
    for(hh in sk2) {
      lockh <- sk==hh
      lkh <- sum(lockh)
      a <-  ( (nk[lockh]- (0: (lkh-1)))  )
      b <- ((Nk[lockh]- (0: (lkh-1)))  )
      c <- prod(1-a/b)
      prk <- prk*(1-c) 
    }
    pkv[k,] <- c(idk, prk)
  }
  pkv 
}






tpsWGEE <- function(formula, data, id, weights=NULL ,     epsilon=1e-6, max.iter=30,    PIij=NULL, w.corr='independent', X_C = NULL, calib=FALSE, weightsDes=NULL, scale.fixed=TRUE, scale=1, initB=NULL, link='logit', ... )
{  
  
  # weights=NULL ;     epsilon=1e-6; max.iter=30; Deltaij =NULL; PIij=NULL; w.corr='independent'; X_C = NULL; calib=FALSE; weightsDes=NULL; scale.fixed=TRUE; scale=1; initB=NULL
  
  #  formula=formulaS;  data=    Data.Samp; id=Data.Samp$idc; weights=Data.Samp$wgt
  
  weights0    <-   weightsDes 
  if(is.null(weights))  {   weights <- rep(1, nrow(data))}
  if(!is.null(weights)) {   weights <- as.vector(weights)}
  
  
  Con2   <- (!is.null(X_C)) & (calib==TRUE) & ((!is.null(weights0))   )
  Con3   <- (is.null(X_C)) & (calib==FALSE) & (is.null(weights0))
  if(!Con2 & !Con3){stop('In order to obtain calibration estimates for the variance all three arguments (X_C , calib and weightsDes)  are required ')}
  
  if(is.null(PIij)) { PIij <-  (1/weights)%*%t((1/weights)); diag(PIij) <- 1/weights 
                      Deltaij <- diag(1/weights - 1/weights^2) }
  
  if(!is.null(PIij)) {   Deltaij <-  PIij-  (1/weights)%*%t((1/weights))}
  
   
  
  
  
  
  # Sorted by cluster
  
  wts2      <- weights
  wts       <- weights
  if(Con2){  
    wts2     <- weights0 }
  
  
  data$wts2    <- wts2
  
  cl <- match.call()
    mf <- match.call(expand.dots = TRUE)
   m  <-  match(c("formula", "data", "id", "weights"  ), names(mf), 0L)
  mf <- mf[c(1L, m)]
  mf$drop.unused.levels <- TRUE
   mf[[1L]] <- quote(stats::model.frame)
  mf <- eval(mf, parent.frame())
   mt <- attr(mf, "terms")
    Y <- model.response(mf, "numeric")
    X <- model.matrix(mt, mf)
   N <- nrow(X)
   Alp.Hat<-0  ;   phi   <-1 ;
  
  Y <- data$Y;  X <- model.matrix(formula, data);  N <- nrow(X);  Alp.Hat<-0  ;   phi   <-1 ;
  #Initial values
  
  
  
   if(link=='logit') {   fit.glm  <-  tryCatch(glm(formula, data, family=binomial ) , error=function(e){}, warning=function(e){} )
   if(is.null(fit.glm)) {  fit.glm  <-  tryCatch(glm(formula, data, family=binomial , weights=wts2) , error=function(e){}, warning=function(e){} ) 
   if(is.null(fit.glm)) {  fit.glm  <-  tryCatch(glm(formula, data, family=binomial, weights=  wts2/sum(wts2) ) , error=function(e){}, warning=function(e){} ) }
   }
   
   if(is.null(fit.glm) & is.null(initB) ) {stop("Unable to set initial values, set initial values") }
   }
   
   if(link=='log') {  fit.glm  <-  tryCatch(glm(formula, data, family=quasibinomial(log), weights=  wts2/sum(wts2) ) , error=function(e){}, warning=function(e){} )
   fit.glm  <-  tryCatch(glm(formula, data, family=binomial(log) ) , error=function(e){}, warning=function(e){} )
   if(is.null(fit.glm)) {  fit.glm  <-  tryCatch(glm(formula, data, family=binomial(log) , weights=wts2) , error=function(e){}, warning=function(e){} ) 
   if(is.null(fit.glm)) { fit.glm  <-  tryCatch(glm(formula, data, family=binomial(log) ) , error=function(e){}, warning=function(e){} ) }
   }
   
   if(is.null(fit.glm) & is.null(initB) ) {stop("Unable to set initial values, set initial values") }
   
   }
   
  
  
  
  
  #  X <- model.matrix(fit.glm)
  #  Y <- model.response(model.frame(fit.glm))
  
  
  
  if(is.null(initB) ) {beta.start  <- fit.glm$coef} 
  if(!is.null(initB) ) {beta.start <- initB} 
  
  
  
  beta.hat   <- beta.start      ; ids        <- unique(id)       ; K          <- length(ids)        ;  p          <- length(beta.hat)  
  PIijK      <- matrix(0, N, N) ; AuxSumK    <- matrix(0, N, K)  ; 
  WW         <- diag(wts)       ; WW2        <- matrix(wts, length(wts), length(wts), byrow=TRUE)
  
  for(k in 1:K) { loc                  <-  id == ids[k] 
                  PIijK[ loc, loc]     <-  PIij[ loc, loc]  ;  AuxSumK[id == ids[k], k ]<-1 } 
  
  DelKInd   <-  (PIijK)  ;  DelKInd[DelKInd != 0] <- 1   
  phi       <- scale     ;  
  
  if(link=='logit') { mu   <-   as.vector(1/(1+exp(-X %*% beta.hat))) ; V    <-  diag((mu*(1-mu)))  
                      
                      if(w.corr=='independent') {   NewRap<- fitMeInd(Y, X, beta.hat, wts,   p,DelKInd, WW2, max.iter ,scale.fixed,epsilon, phi,PIij ) } 
                      if(w.corr=='exchangeable') {   NewRap<- fitMeExc(Y,X, id,  beta.hat, wts,  p, DelKInd, WW2, max.iter ,  V, scale.fixed, epsilon, phi, PIij,N, ids, K)  } 
  }
  
  if(link=='log') {  mu   <-   as.vector(exp(X %*% beta.hat)) ; V    <-  diag((mu*(1-mu)))  
                     
                     if(w.corr=='independent') {   NewRap<- fitMeIndLog(Y, X, beta.hat, wts,   p,DelKInd, WW2, max.iter ,scale.fixed,epsilon, phi,PIij ) } 
                     if(w.corr=='exchangeable') {   NewRap<- fitMeExcLog(Y,X, id,  beta.hat, wts,  p, DelKInd, WW2, max.iter ,  V, scale.fixed, epsilon, phi, PIij,N, ids, K)  } 
  }
  
  beta.hat=NewRap$beta.hat  
  mu=NewRap$mu   
  phi=NewRap$phi  
  D=NewRap$D  
  V=NewRap$V 
  Vd=NewRap$Vd 
  Vinv=NewRap$Vinv 
  Aux3=NewRap$Aux3 
  Ubb.wT= NewRap$Ubb.wT 
  Aux4=  NewRap$Aux4 
  Aux5=NewRap$Aux5  
  Ibb.w= NewRap$Ibb.w  
  Ibb.w.inv= NewRap$Ibb.w.inv 
  converged=NewRap$converged 
  Alp.Hat = NewRap$Alp.Hat
  iteration = NewRap$iteration
  
  VWW          <-  Vinv%*%WW 
  Ubb.w        <-  t(t(D) %*% VWW  * matrix((Y - mu), nrow=p, ncol=N, byrow=TRUE))
  Ubb.K        <-  t(AuxSumK) %*% Ubb.w 
  Fbb.w.Orig   <-  var(Ubb.K)* (K-1)  
  Ibb.w        <-  (t(D) %*%  VWW %*% D)
  Ibb.w.inv    <-  tryCatch(solve(Ibb.w), error=function(e){})
  AuxF         <-  (Vinv* DelKInd ) %*%(D*wts)
  F0Aux        <-  t(D*wts) %*%  AuxF 
  naive.V      <-  Ibb.w.inv   
  robust.V0    <-  Ibb.w.inv %*% ( Fbb.w.Orig ) %*% Ibb.w.inv                ## The original "Direct" calculation
  betaHat      <-  beta.hat;  
  muhat        <-  mu;  
  Vhat         <-  V  ;  Dhat     <- D;  Vinvh    <- Vinv
  Scor         <-  (Vinvh %*% Dhat) * (Y-muhat);
  Aux00        <-  t(Dhat*wts)
  Aux0         <-  Vinvh %*% Dhat
  Icr          <-  Aux00  %*% Aux0
  Icr.inv      <-  try(solve(Icr))   
  ScorWE       <-  Scor * wts
  DeltaHat     <-  Deltaij / PIij
  Aux1a        <-  DeltaHat*(wts%*%t(wts) ) 
  Aux2a        <-  DelKInd * Aux1a
  Fcr.1        <-  t(Dhat*wts) %*% (Vinvh) %*% (Dhat*wts)    #t(Scor) %*% (wts* Scor) ## This is the phase I estimate assuming independence.
  Fcr.1a       <-  t(Scor) %*% (wts* Scor) ## This is the phase I estimate assuming independence.
  Fcr.2        <-  t(Scor) %*% (Aux1a)%*% Scor  ## This is the phase II estimate. 
  Fcr.1b       <-  t(Scor) %*% (DelKInd / PIij) %*% Scor          ## This is unbiased phase I estimate accounting for clustering- \sum_k E( Score^k Wij^k Score^k )= E( \sum_k U_k U_k')
  Fcr.2bK      <-  t(Scor) %*% (Aux2a) %*% Scor  ## This is unbiased phase II estimate accounting for clustering- \sum_k E( Score_we^k Deltaij^k*Wij^k  Score*we^k )= \sum_k E(  \sum_k \hat{U}_k Deltaij^k  \hat{U}_k')
  LLAux        <-  t(Scor) %*% (wts^2* Scor)   
  LLAux_Nv     <-  Fcr.1a  + Fcr.2    
  if(Con2){ 
    wts3  <-  wts    
    
    
   
    
    X_C         <-  cbind( as.matrix(X_C )  )
    AuxB_C      <-  tryCatch(solve(t(X_C*wts3)%*% (X_C)), error=function(e){})
    B_C         <-  AuxB_C%*% (t(X_C* wts3) %*% Scor  )
    E           <-  Scor- X_C%*%B_C
    MeanE       <-  matrix(colSums(wts3*E)/N,nrow(E), ncol(E), byrow=TRUE)
    E           <-  E- MeanE
    ee          <-  Scor
    for(pl in 1: ncol(Scor)) {
      modf        <-  glm(Scor[, pl]~ 0 + X_C, weights= wts3)
      ee[, pl]          <- Scor[, pl]- fitted(modf)
    }
    
    E           <- ee
    
    ## add
  
    
    Aux1a00     <-  DeltaHat*(wts3%*%t(wts3) ) ## Solo cambie esto
    Aux2a00     <-  DelKInd * Aux1a00
    
    Fcr.2       <-  t(E) %*% (Aux1a00)%*% E  ## This is the phase II estimate. 
    Fcr.2bK     <-  t(E) %*% (Aux2a00) %*%E  ## This is unbiased phase II estimate accounting for clustering- \sum_k E( Score_we^k Deltaij^k*Wij^k  Score*we^k )= \sum_k E(  \sum_k \hat{U}_k Deltaij^k  \hat{U}_k')
    LLAux       <-  t(E) %*% ((wts3^2 - wts3)*E)  +  t(Scor) %*% (wts3* Scor)
    
 
    Fcr.2cal    <-  t(E) %*% (Aux1a00)%*% E   
  
    LLAux_Nv    <-  Fcr.2cal   +  t(Scor) %*% (wts3* Scor) 
    
 
    }
  
  robust.VC0_S    <- Icr.inv %*%( LLAux_Nv    ) %*% Icr.inv           ### Variance ignoring clustering, but accounting for sampling covariance  
  robust.VC0      <- Icr.inv %*%( LLAux   ) %*% Icr.inv               ### Variance ignoring clustering and assuming independent second phase sample. 
  robust.VCK_SK   <- Icr.inv %*%( Fcr.1b  + Fcr.2bK  ) %*% Icr.inv    ### Variance accounting for only clustering, and assuming independent sampling between clusters - this is the usuall robust estimator
  robust.VCK_S    <- Icr.inv %*%( Fcr.1b  + Fcr.2    ) %*% Icr.inv    ### Variance accounting for two-phase sampling and clustering. 
  robust.VCS_S    <- Ibb.w.inv %*%( Fcr.1  ) %*% Ibb.w.inv            ### Model based  
  
  
  value           <- list( beta=beta.hat, Naive_Cov=naive.V, Cov.S=robust.VC0_S ,  Cov.Ind=robust.VC0, Cov._K_K=robust.VCK_SK,  Cov._K_S=robust.VCK_S,  Cov._MB=robust.VCS_S, 
                           names=colnames(X), converge=converged, Alp.Hat=Alp.Hat, phi=phi, itera= iteration  )
  
  value$calib       <- calib
  value$w.corr      <- w.corr 
  value$scale       <- scale
   class(value )     <- "tpsWGEE"  
   value$xlevels     <- .getXlevels(mt, mf)
   value$call <- cl
    value$terms <- mt
  value$K<-K
  
  if(converged==FALSE)  stop("Method did not converge!")
  
  
  
  mul1               <-     K/(K-length(beta.hat))
  
  
  value3 <- cbind(beta.hat,   
                  sqrt(diag(robust.VC0_S)  ) ,  
                  sqrt(diag(robust.VCK_S)  ) ,   
                  sqrt(diag(robust.VC0_S)*mul1  ) ,  
                  sqrt(diag(robust.VCK_S)*mul1  )  )
  dimnames(value3) <- list(colnames(X),      c("Estimate", "Naive SE",   "Robust SE" , "Naive SE-small samp",   "Robust SE-small samp"  ))
  
  
  value4 <- list(  value3=value3, value=value  )
  #value4 <- list(  value3=value3  )
  class(value4)  <- 'tpsWGEE'
  return(value4) 
  
  
}



fitMeInd<-  function(Y,X, beta.hat, wts,   p,DelKInd, WW2, max.iter,scale.fixed,epsilon,phi, PIij,... ) 
{  converged <- FALSE;    iteration <- 0
   while(converged == FALSE) { 
     iteration <- iteration + 1
     ###   Estimation of beta
     mu        <-  as.vector(expit(X %*% beta.hat)) 
     A         <-  sqrt( mu*(1-mu) )
     Pers      <-  (Y - mu) /( A ) ;
     if(scale.fixed==FALSE){  phi     <-  sum(Pers^2*wts)/(sum(wts)-p)}
     dgV       <-  phi* (A^2)
     V         <-  diag(dgV )  ;  
     Vd        <-  diag(mu*(1-mu))
     Vinv      <-  diag(1/dgV )
     D         <-  (mu*(1-mu))*X
     Aux3      <-  diag(wts/dgV )
     Auxbb     <-  Aux3%*%(Y-mu)
     Ubb.wT    <-  t(D)%*%Auxbb   
     Aux4      <-  t(D) %*% Vinv         
     Aux5      <-  wts*D
     Ibb.w     <-  Aux4 %*% Aux5
     Ibb.w.inv <-  tryCatch(solve(Ibb.w), error=function(e){})
     if(class(Ibb.w.inv) == "try-error")   break;     beta.next <- beta.hat + as.vector(Ibb.w.inv %*% Ubb.wT)
     if(sum(is.na(beta.next)) > 0)         break;     max.diff  <- max(abs(beta.next - beta.hat)) 
     if(max.diff < epsilon) converged <- TRUE
     if(iteration == max.iter) break
     beta.hat <- beta.next  }
   
   val <- list ( beta.hat=beta.hat, mu=mu,  phi=phi, D=D, V=V, Vd=Vd, Vinv=Vinv, Aux3=Aux3, Ubb.wT= Ubb.wT, Aux4=  Aux4,
                 Aux5=Aux5, Ibb.w= Ibb.w, Ibb.w.inv= Ibb.w.inv , converged=converged, Alp.Hat=0, iteration=iteration)
   return(val) }



fitMeExc <- function(Y,X, id,  beta.hat, wts,  p, DelKInd, WW2, max.iter , V0 , scale.fixed, epsilon, phi, PIij,N, ids, K , ...) 
{    
  V           <- V0 
  nClus       <- colSums(table(Y, id))
  ndeno       <- sum(nClus^2 - nClus) - 2 * p
  NClus       <- N; 
  converged   <- FALSE
  iteration   <- 0
  mu          <-  as.vector(expit(X %*% beta.hat)) 
  alp.next    <-  0
  
  
  while(converged == FALSE)
  { iteration <- iteration + 1
    #### Estimation of beta
    
    A       <-  sqrt(mu*(1-mu))
    AA      <-  sqrt(diag(V))
    AA3     <-   sqrt(mu*(1-mu)) 
    Pers    <-  (Y - mu)/AA    ;
    if(scale.fixed==FALSE){  phi  <-  1/(sum(Pers^2*wts)/(sum(wts)))}
    Aux1    <-  Pers %*% t(Pers) 
    Auxaa   <-  DelKInd/PIij  ; diag(Auxaa)<-0
    Deno    <-  sum(Auxaa) 
    CorrM   <-  Aux1* (Auxaa) ;  
    #- 2 * p
    
    Alp.Hat <-  sum(CorrM)*phi/(Deno) 
    
    RR      <-  Alp.Hat*DelKInd  ; diag(RR)<-  1
    Auxd1   <-  (A%*%t(A))
    AAaux   <-  Auxd1*RR  #   (A%*%t(A))*RR  ; 
    V       <-  AAaux    ##  AAaux * RR/phi  ;   
    Vd      <-  diag(mu*(1-mu))
    Vinv    <-  DelKInd
    D         <-  (mu*(1-mu))* X
    # The estimation 
    Aux4K   <-  (X)*0
    
    for(k in 1:K) { 
      
      loc           <-  id == ids[k]
      nik           <-  sum(loc)
      Vk            <-  V[ loc, loc ]
      sdk           <-  A[loc]
      Auxkk         <-  sdk%*%t(sdk)
      
      Corinvk       <-  InVEx(Alp.Hat, nik) 
      Vinvaux       <-  Corinvk* (1/Auxkk) 
      #Vinvaux       <- solve (Auxkk*CORR )
      
      Vinv[loc,loc] <-  Vinvaux 
      Dk            <-  D[loc,]
      Aux4K[loc,]   <-  Vinvaux%*%Dk  
    }
    
    Aux4K     <- t(Aux4K)
    
    
    Aux3      <-  t( Vinv *wts  )
    Auxbb     <-  Aux3%*%(Y-mu)
    Ubb.wT    <-  t(D)%*%Auxbb   
    Aux4      <-  Aux4K#t(D) %*%( Vinv)
    Aux5      <-  wts*D # WW %*% D
    Ibb.w     <-  Aux4 %*% Aux5
    
    Ibb.w.inv <-  tryCatch(solve(Ibb.w), error=function(e){})
    
    if(class(Ibb.w.inv) == "try-error")     break  ;  beta.next <- beta.hat + as.vector(Ibb.w.inv %*% Ubb.wT)
    if(sum(is.na(beta.next)) > 0 | sum(is.na(alp.next)) > 0  )        stop('not converge') ;   max.diff  <- max(abs(beta.next - beta.hat)) ; max.diffalp <-  max(abs(alp.next - Alp.Hat))
    if(max.diff < epsilon & max.diffalp < epsilon)                 converged <- TRUE
    if(iteration == max.iter)               break;
    
    alp.next  <- Alp.Hat
    beta.hat <- beta.next 
    mu      <-  as.vector(expit(X %*% beta.hat)) 
    
    
    
  } 
  
  val <- list ( beta.hat=beta.hat, mu=mu,  phi=phi, D=D, V=V, Vd=Vd, Vinv=Vinv, Aux3=Aux3, Ubb.wT= Ubb.wT, Aux4=  Aux4,
                Aux5=Aux5, Ibb.w= Ibb.w, Ibb.w.inv= Ibb.w.inv , converged=converged, Alp.Hat=Alp.Hat, iteration=iteration)
  
  
  return(val) }

library(compiler)
fitMeExc <- cmpfun(fitMeExc)
fitMeInd <- cmpfun(fitMeInd)
###########################
fitMeIndLog<-  function(Y,X, beta.hat, wts,   p,DelKInd, WW2, max.iter,scale.fixed,epsilon,phi, PIij,... ) 
{  converged <- FALSE;    iteration <- 0
   while(converged == FALSE) { 
     iteration <- iteration + 1
     ###   Estimation of beta
     mu        <-  as.vector(exp(X %*% beta.hat)) 
     A         <-  sqrt( mu*(1-mu) )
     Pers      <-  (Y - mu) /( A ) ;
     if(scale.fixed==FALSE){  phi     <-  sum(Pers^2*wts)/(sum(wts)-p)}
     dgV       <-  phi* (A^2)
     V         <-  diag(dgV )  ;  
     Vd        <-  diag(mu*(1-mu))
     Vinv      <-  diag(1/dgV )
     D         <-  (mu)*X
     Aux3      <-  diag(wts/dgV )
     Auxbb     <-  Aux3%*%(Y-mu)
     Ubb.wT    <-  t(D)%*%Auxbb   
     Aux4      <-  t(D) %*% Vinv         
     Aux5      <-  wts*D
     Ibb.w     <-  Aux4 %*% Aux5
     Ibb.w.inv <-  tryCatch(solve(Ibb.w), error=function(e){})
     if(class(Ibb.w.inv) == "try-error")   break;     beta.next <- beta.hat + as.vector(Ibb.w.inv %*% Ubb.wT)
     if(sum(is.na(beta.next)) > 0)         break;     max.diff  <- max(abs(beta.next - beta.hat)) 
     if(max.diff < epsilon) converged <- TRUE
     if(iteration == max.iter) break
     beta.hat <- beta.next  }
   
   val <- list ( beta.hat=beta.hat, mu=mu,  phi=phi, D=D, V=V, Vd=Vd, Vinv=Vinv, Aux3=Aux3, Ubb.wT= Ubb.wT, Aux4=  Aux4,
                 Aux5=Aux5, Ibb.w= Ibb.w, Ibb.w.inv= Ibb.w.inv , converged=converged, Alp.Hat=0, iteration=iteration)
   return(val) }



fitMeExcLog <- function(Y,X, id,  beta.hat, wts,  p, DelKInd, WW2, max.iter , V0 , scale.fixed, epsilon, phi, PIij,N, ids, K , ...) 
{    
  V           <- V0 
  nClus       <- colSums(table(Y, id))
  ndeno       <- sum(nClus^2 - nClus) - 2 * p
  NClus       <- N; 
  converged   <- FALSE
  iteration   <- 0
  mu          <-  as.vector(exp(X %*% beta.hat)) 
  alp.next    <-  0
  
  
  while(converged == FALSE)
  { iteration <- iteration + 1
    #### Estimation of beta
    
    A       <-  sqrt(mu*(1-mu))
    AA      <-  sqrt(diag(V))
    AA3     <-   sqrt(mu*(1-mu)) 
    Pers    <-  (Y - mu)/AA    ;
    if(scale.fixed==FALSE){  phi  <-  1/(sum(Pers^2*wts)/(sum(wts)))}
    Aux1    <-  Pers %*% t(Pers) 
    Auxaa   <-  DelKInd/PIij  ; diag(Auxaa)<-0
    Deno    <-  sum(Auxaa) 
    CorrM   <-  Aux1* (Auxaa) ;  
    #- 2 * p
    
    Alp.Hat <-  sum(CorrM)*phi/(Deno) 
    
    RR      <-  Alp.Hat*DelKInd  ; diag(RR)<-  1
    Auxd1   <-  (A%*%t(A))
    AAaux   <-  Auxd1*RR  #   (A%*%t(A))*RR  ; 
    V       <-  AAaux    ##  AAaux * RR/phi  ;   
    Vd      <-  diag(mu*(1-mu))
    Vinv    <-  DelKInd
    D         <-  (mu)* X
    # The estimation 
    Aux4K   <-  (X)*0
    
    for(k in 1:K) { 
      
      loc           <-  id == ids[k]
      nik           <-  sum(loc)
      Vk            <-  V[ loc, loc ]
      sdk           <-  A[loc]
      Auxkk         <-  sdk%*%t(sdk)
      
      Corinvk       <-  InVEx(Alp.Hat, nik) 
      Vinvaux       <-  Corinvk* (1/Auxkk) 
      #Vinvaux       <- solve (Auxkk*CORR )
      
      Vinv[loc,loc] <-  Vinvaux 
      Dk            <-  D[loc,]
      Aux4K[loc,]   <-  Vinvaux%*%Dk  
    }
    
    Aux4K     <- t(Aux4K)
    
    
    Aux3      <-  t( Vinv *wts  )
    Auxbb     <-  Aux3%*%(Y-mu)
    Ubb.wT    <-  t(D)%*%Auxbb   
    Aux4      <-  Aux4K#t(D) %*%( Vinv)
    Aux5      <-  wts*D # WW %*% D
    Ibb.w     <-  Aux4 %*% Aux5
    
    Ibb.w.inv <-  tryCatch(solve(Ibb.w), error=function(e){})
    
    if(class(Ibb.w.inv) == "try-error")     break  ;  beta.next <- beta.hat + as.vector(Ibb.w.inv %*% Ubb.wT)
    if(sum(is.na(beta.next)) > 0 | sum(is.na(alp.next)) > 0  )        stop('not converge') ;   max.diff  <- max(abs(beta.next - beta.hat)) ; max.diffalp <-  max(abs(alp.next - Alp.Hat))
    if(max.diff < epsilon & max.diffalp < epsilon)                 converged <- TRUE
    if(iteration == max.iter)               break;
    
    alp.next  <- Alp.Hat
    beta.hat <- beta.next 
    mu      <-  as.vector(exp(X %*% beta.hat)) 
    
    
    
  } 
  
  val <- list ( beta.hat=beta.hat, mu=mu,  phi=phi, D=D, V=V, Vd=Vd, Vinv=Vinv, Aux3=Aux3, Ubb.wT= Ubb.wT, Aux4=  Aux4,
                Aux5=Aux5, Ibb.w= Ibb.w, Ibb.w.inv= Ibb.w.inv , converged=converged, Alp.Hat=Alp.Hat, iteration=iteration)
  
  
  return(val) }

library(compiler)
fitMeExcLog <- cmpfun(fitMeExcLog)
fitMeIndLog <- cmpfun(fitMeIndLog)
###########################
#############################


###########################

#myWGEE<-function(x,...){
#     UseMethod("myWGEE",x )
#  }




confint.tpsWGEE<- function(object , level = 0.95 )
{
  
  t0       <- qnorm(level, 0,1)
  beta     <- object$value3[, 1] 
  coeffse  <- object$value3[, -1]  
  cnam    <- colnames(coeffse)
  rnam    <- rownames(coeffse)
  ci     <- matrix(paste("(",round(beta-t0*coeffse,2), ', ',round(beta+t0*coeffse,2),")", sep=''  ), dim(coeffse)) ; 
  colnames(ci) <-cnam
  rownames(ci) <- rnam
  ci <-data.frame(ci)
  
  return(ci) 
  
}



print.tpsWGEE<-function(object,...) {
  cat( "Call:", "\n" ) ;  
  print( object$value$call);  cat('\n'," Coefficients:", "\n" ) ;    
  print(round(object$value3,3) );  
  cat( "\nConverged= " , object$value$converged, ", Correlation Str.= " ,object$value$w.corr , ", Alpha= "  , object$value$Alp.Hat,   "\nNumber of clusters= "  , object$value$K,', ',"Calibrated weights= ", object$value$calib  );
}






summary.tpsWGEE<-function(object, ...) 
{
  ## Varchoice
  ## c("Naive estimator of the variance","Two-phase, non-clustered", "Independent sampling, non-clustered", "Standard Robust estimator(clustered)", "Two-phase Robust estimator(clustered)" )
  ##   1 , 2, 3,4, 5
  ##   Naive_SE, SE.S  , Cov.Ind , Cov._K_K , Cov._K_S 
  
  coeff    <- object$value3
  alpha    <- object$value$Alp.Hat 
  converged<- object$value$converged 
  Alp.Hat  <- object$value$Alp.Hat 
  phi      <- object$value$phi
  conInt   <- confint(object)
  
  coeffse  <- object$value3[, -1] 
  beta    <- object$value3[,1]
  cnam    <- colnames(coeffse)
  rnam    <- rownames(coeffse)
  
  pvalue   <-  2 * pnorm(-abs(beta)/coeffse) 
  colnames(pvalue)  <- cnam
  rownames(pvalue)  <- rnam
  
  coef.table <- data.frame( round(beta,2), round(coeffse,3),  round(pvalue ,4), conInt   )
  dimnames(coef.table) <- list(rnam, c("Est.",cnam, paste("pval-", cnam),paste("CI-", cnam) ))
  ans<- list(  converged= object$value$converged,  itera= object$value$itera ,  w.corr=  object$value$w.corr,  
               alpha=object$value$Alp.Hat, phi= object$value$phi,   
               K=object$value$K,  call=object$value$call,  calib= object$value$calib ,   coeff=coef.table  # calib= object$valuecalib ,
  )
  class(ans) <- "summary.tpsWGEE"
  
  
  
  ans
} 

print.summary.tpsWGEE<-function(object,...) {
  cat( "Call:", "\n" ) ;  
  print( object$call);  cat('\n'," Coefficients:", "\n" ) ;    
  print( object$coeff );  
  cat( "\nConverged= " , object$converged, ", Max. iter.= " , object$itera  ,     ", Correlation Str.= " ,object$w.corr , 
       ", alpha= ",   round(object$alpha,3) ,   "\nphi = ",round( object$phi,3) ,    ", Number of clusters= "  ,        object$K,  
       ", Calibrated weights= ", object$calib    );
}




















